//
//See EventLogWriter.h for details
//

#include "stdafx.h"
#include "EventLogWriter.h"							//Function to writeto the Event log


// **************************************************************************
//DESCRIPTION:
//		Display a message in the EventLog.
//		this is usually come kind of status or error message.
//PARAMS:
//		wType	Type of Event to Raise ie EVENTLOG_ERROR_TYPE
//		fmt		Message to be displayed printf formatted (512 bytes limit)
//CREATED:
//		12-5-2000, 11:41:16 by John McTainsh
// ***************************************************************************
void WriteEvent( WORD wType, const char *fmt, ... )
{
	const int nBuffSize = 512;						//Maximum message length

	//
	//Build the buffer
	//
	TCHAR *szMess = new TCHAR[nBuffSize+1]; 			// Buffer to build sting into   
	if( szMess == NULL )
	{
		TRACE( _T("Display() failed to create a buffer (MEMORY LOW!!!)\n") );
		return;
	}

	va_list  argptr;     							// Argument list pointer        
	va_start( argptr, fmt );						// Initialize va_ functions	
	_vsntprintf( szMess, nBuffSize, fmt, argptr );	// prints string to buffer      
	szMess[nBuffSize] = NULL;						// Close off if Overflow occured
	va_end( argptr );	   							// Close va_ functions 

	//
	//Output the Data to the Event Log
	//
	SetLastError( 0 );
	HANDLE hEventSource = RegisterEventSource( NULL, EVENT_APP_TITLE );

	LPCTSTR lpStrings = szMess;

	BOOL bRet = ReportEvent(
						hEventSource,			// handle to event log
						wType,					// event type
						BUILD_NO_NO,			// event category
						MC_PLAIN_TEXT_1,		// event identifier
						NULL,					// user security identifier
						1,						// number of strings to merge
						0,						// size of binary data
						&lpStrings,				// array of strings to merge
						NULL );					// binary data buffer

	DeregisterEventSource( hEventSource );

	//
	//Free memory
	//
	delete [] szMess;
}
